import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Character here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Character extends Actor {
    private int currentFrame = 0;
    private int timeBetweenFrame = 20;
    private int currentTimeBetweenFrame;
    private int size;
    private Color color;
    private static final int[][][] character = new int[][][] {
                                               {{0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0},
                                                {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1},
                                                {1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1},
                                                {1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
                                                {0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0},
                                                {0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0}},
                                               {{0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0},
                                                {0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0},
                                                {0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0},
                                                {0, 1, 1, 0, 1, 1, 1, 0, 1, 1, 0},
                                                {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
                                                {1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1},
                                                {1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1},
                                                {0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0}}
                                            };
                   
    private int highestFrameNumber = character.length - 1;
    
    public Character(int size, Color color) {
        this.size = size;
        this.color = color;
        
        initializeImage();
    }
    
    /**
     * Act - do whatever the Character wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() {
        animate();
    }
    
    private void animate() {
        if (currentTimeBetweenFrame % timeBetweenFrame == 0) {
            changeImage();
        }
        
        currentTimeBetweenFrame++;
    }
    
    private void changeImage() {
        currentFrame++;
            
        if (currentFrame > highestFrameNumber) {
            currentFrame = 0;
        }
        
        initializeImage();
    }
    
    private void initializeImage() {
        getImage().clear();
        
        int widthArr = character[currentFrame][0].length;
        int heightArr = character[currentFrame].length;
        
        getImage().scale(widthArr * size, heightArr * size);
        getImage().setColor(color);
        
        for (int y = 0; y < heightArr; y++) {
            for (int x = 0; x < widthArr; x++) {
                if (character[currentFrame][y][x] == 1) {
                    int widthImage = getImage().getWidth();
                    int heightImage = getImage().getHeight();
                    
                    getImage().fillRect(x * size, y * size, widthImage / widthArr, heightImage / heightArr);
                }
            }
        }
    }
}
